// This script implements the Plugins>Tools>Signed 16-bit to 
// Unsigned command.  What it does is convert signed 16-bit 
// images and stacks to unsigned.
// Modified by Matevž Bokalič, UL FE, 7.12.2020 
//  - removed normalization: now it does what it should actually do. Only converts, nothing else.
importClass(Packages.ij.IJ);
importClass(Packages.ij.process.StackStatistics);
imp = IJ.getImage();
stack = imp.getStack();
if (stack.isVirtual())
 IJ.error("Non-virtual stack required");
cal = imp.getCalibration();
if (!cal.isSigned16Bit()){
 IJ.error("Signed 16-bit image required");}
else {
	cal.disableDensityCalibration();
	ip = imp.getProcessor();
	min = 0;
	max = 32767;
	stats = new StackStatistics(imp);
	minv = 32768;
	for (i=1; i<=stack.getSize(); i++) {
	 ip = stack.getProcessor(i);
	 ip.add(-minv);
	}
	imp.setStack(stack);
	ip = imp.getProcessor();
	ip.setMinAndMax(stats.min-minv, stats.max-minv);
	imp.updateAndDraw();
}